import java.util.*;
import java.net.*;
import java.io.*;
import javax.swing.*;

public class Listener extends Thread {
  Client c_;
  byte buf_[];
  DatagramPacket p_;

  Listener(Client c) { 
    c_ = c;
    allocPacket();
  }

  private void allocPacket() {
    buf_ = new byte[1600];
    p_ = new DatagramPacket(buf_, buf_.length);
  }

  public void run() {
    while (true) {
      try { c_.getSocket().receive(p_); }
      catch (IOException x) {
	System.out.println("Listener.receive exception, " + x.getMessage());
	continue;
      }
      DatagramPacket currPkt = p_;
      allocPacket(); // set p_ to new storage for next rx packet;
      SwingUtilities.invokeLater(new Client.ClientReceiver(c_, currPkt));
    }
  }
}
